function getObjectDiv(eid) {
	var divs=oFindChildren(document.body, 'DIV', 'OBJECT');
	for (var i=divs.length; i--;) {
		if (divs[i].eid == eid)
			return divs[i];
	}
	return null;
}

function getObjectDivs(eid) {
	var divs=oFindChildren(document.body, 'DIV', 'OBJECT');
	var ret=[];
	for (var i=divs.length; i--;) {
		if (divs[i].eid == eid)
			ret.push(divs[i]);
	}
	return ret;
}

function oFindParentById(node, id) {
	if (!node || !id) return null;
	while (node && node.tagName != 'BODY') {
		if (node.id == id) return node;
		node=node.parentNode;
	}
	return null;
}

function oFindParentByTagName(node, tag) {
	if (!node || !tag) return null;
	while (node && node.tagName != 'BODY') {
		if (node.tagName == tag) return node;
		node=node.parentNode;
	}
	return null;
}

function oFindParentByClassName(node, className) {
	if (!node || !className) return null;
	while (node && node.tagName != 'BODY') {
		if (node.className == className) return node;
		node=node.parentNode;
	}
	return null;
}

function oFindChild(node, tag, id) {
	var childs=oFindChildByTagNames(node, tag);
	if (childs) {
		for (var i=0; i < childs.length; i++) {
			if (childs[i].id == id) return childs[i];
		}
	}
	return null;
}

function oFindChildren(node, tag, id) {
	var childs=oFindChildByTagNames(node, tag);
	var ret=[];
	if (childs) {
		for (var i=0; i < childs.length; i++) {
			if (childs[i].id == id) ret.push(childs[i]);
		}
	}
	return ret;
}

function oFindChildByTagName(node, tag) {
	if (!node) return null;
	if (node.tagName == tag) return node;
	var nodes=node.getElementsByTagName(tag);
	if (nodes) return nodes[0];
	else return null;
}

function oFindChildByTagNames() {
	if (arguments.length < 2) return [];
	var parentNode=arguments[0];
	var ret=[];
	for (var i=1; i < arguments.length; i++) {
		var nodes=parentNode.getElementsByTagName(arguments[i]);
		for (var p=0; p < nodes.length; p++)
			ret.push(nodes[p]);
	}
	return ret;
}

function oFindChildTextNode(node) {
	if (!node) return null;
	for (var i=0; i < node.childNodes.length; i++) {
		if (node.childNodes[i].nodeType == 3)
			return node.childNodes[i];
	}
	return null;
}

function oChildByTag(node, tag) {
	if (!node || !tag || !node.hasChildNodes()) return null;
	for (var i=0; i < node.childNodes.length; i++) {
		if (node.childNodes[i].tagName == tag) return node.childNodes[i];
	}
	return null;
}

function oFindPrevSiblingByTag(node, tag) {
	if (!node || !tag || !node.previousSibling) return node;
	for (var brother=node; brother; brother=brother.previousSibling) {
		if (brother.tagName == tag) return brother;
	}
	return null;
}

function oFindNextSiblingByTag(node, tag) {
	if (!node || !tag || !node.nextSibling) return node;
	for (var brother=node; brother; brother=brother.nextSibling) {
		if (brother.tagName == tag) return brother;
	}
	return null;
}

function isObject(obj) {
	if (!obj || !obj.constructor) return false;
	return (obj.constructor.toString().indexOf("Object") != -1);
}

function isFunction(obj) {
	return (typeof obj == 'function' || typeof obj == 'object');
}

